import { WrappedRange, WrappedSelection, RangyRangeEx } from "@rangy/core";
import { ClassApplier } from "@rangy/classapplier";
interface SerializedSelectionT {
    characterRange: CharacterRange;
    backward: boolean;
}
declare type ConverterCreator = () => Converter;
interface Converter {
    type?: string;
    rangeToCharacterRange(range: RangyRangeEx, containerNode?: Node): CharacterRange;
    characterRangeToRange(doc: Document | Window | HTMLIFrameElement, characterRange: CharacterRange, containerNode: Node): WrappedRange;
    serializeSelection(selection: WrappedSelection, containerNode: Node): SerializedSelectionT[];
    restoreSelection(selection: WrappedSelection, savedSelection: SerializedSelectionT[], containerNode: Node): void;
}
export declare function registerHighlighterType(type: string, converterCreator: ConverterCreator): void;
declare class CharacterRange {
    start: number;
    end: number;
    constructor(start: number, end: number);
    intersects(charRange: any): boolean;
    isContiguousWith(charRange: any): boolean;
    union(charRange: any): CharacterRange;
    intersection(charRange: any): CharacterRange;
    getComplements(charRange: any): any[];
    toString(): string;
    static fromCharacterRange(charRange: any): CharacterRange;
}
export declare class Highlighter {
    classAppliers: {};
    highlights: any[];
    doc: Document;
    converter: Converter;
    constructor(doc?: Document, type?: string);
    addClassApplier(classApplier: ClassApplier): void;
    getHighlightForElement(el: any): any;
    removeHighlights(highlights: any): void;
    removeAllHighlights(): void;
    getIntersectingHighlights(ranges: any): any[];
    highlightCharacterRanges(className: any, charRanges: any, options?: any): any[];
    highlightRanges(className: any, ranges: any, options?: any): any[];
    highlightSelection(className: any, options?: any): any[];
    unhighlightSelection(selection: any): any[];
    getHighlightsInSelection(selection: any): any[];
    selectionOverlapsHighlight(selection: any): boolean;
    serialize(options?: any): any;
    deserialize(serialized: any): void;
}
export declare function createHighlighter(doc?: Document, rangeCharacterOffsetConverterType?: string): Highlighter;
export {};
//# sourceMappingURL=index.d.ts.map